//+------------------------------------------------------------------+
//|                                                    StepMA EA.mq4 |
//|                                                         Laurence |
//|                                                                  |
//+------------------------------------------------------------------+

// Note: It seems to work better when buy is sell and visa versa

#property copyright "Laurence"
#property link      ""

//---- input parameters
extern int  maxTrades = 1;
extern int  Slippage = 3;
extern double  lotStep = 0.1;
extern double  lotSize = 1;
extern double  maxLot = 50;
extern double  minLot = 1;
extern bool MM = false;
extern double TP = 0;
extern double SL = 0;
double StepMA;
int LastBar;
int pos = OP_BUY;
int ticket;
int MagicNumber = 1337;
int init()
  {
   Print("Trading on",Symbol(),".");
   return(0);
  }
int deinit()
  {
   return(0);
  }
int start()
  {
   double TakeProfit = 0;
   double StopLoss = 0;
   
   if(LastBar + (Period() * 60) < TimeCurrent()) {
   StepMA = iCustom(Symbol(), Period(), "StepMA", 10, 0, 1); LastBar = TimeCurrent(); Print("StepMA: ", StepMA);
      if(StepMA >= 0) {
         closeEm(0);
         if(OrdersTotal() <= maxTrades) {
            if(TP > 0) TakeProfit = Ask + TP * Point;
            if(SL > 0) StopLoss = Ask - SL * Point;
            Print("Buy, Trade ",OrdersTotal(),"/",maxTrades);
            ticket = OrderSend(Symbol(), OP_BUY, lotSize, Ask, Slippage, StopLoss, TakeProfit, 0, MagicNumber);
         }
      } else {
         closeEm(1);
         if(OrdersTotal() <= maxTrades) {
            if(TP > 0) TakeProfit = Bid - TP * Point;
            if(SL > 0) StopLoss = Bid + SL * Point;
            Print("Sell, Trade ",OrdersTotal(),"/",maxTrades);
            ticket = OrderSend(Symbol(), OP_SELL, lotSize, Bid, Slippage, StopLoss, TakeProfit, 0, MagicNumber);
         }
      }
   }
   return(0);
  }
int closeEm(int p)
  {
   int total = OrdersTotal();
   for (int cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
      if(OrderMagicNumber() == MagicNumber) {
         if(OrderProfit() > 0 && MM) { if(lotSize < maxLot) lotSize += lotStep; } else if(MM) { if(lotSize > minLot) lotSize -= lotStep; else lotSize = minLot; }
         if(OrderType()==OP_BUY && p == 1) {
          OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Violet);
         }
         if(OrderType()==OP_SELL && p == 0) {
          OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Violet);
         }
     }
  }
  }